import { Component, Input, OnChanges, SimpleChanges } from '@angular/core';
import { IContextNode } from 'app/services/i-context-node';
import { MockCtxloaderService } from 'app/services/mock-ctxloader.service';
import { IHostingnode } from 'app/services/i-hostinngnode';
import { ResourcesLoaderService } from 'app/services/resources-loader.service';

@Component({
  selector: 'jhi-ctx-screen',
  templateUrl: './ctx-screen.component.html',
  styleUrls: ['./ctx-screen.component.scss'],
  providers: [MockCtxloaderService, ResourcesLoaderService],
})
export class CtxScreenComponent implements OnChanges {
  dataSource: IHostingnode[];
  fetchedRawData?: string;
  tableDetail: IHostingnode;

  @Input() myCtx: IContextNode; //fetching event from parent

  constructor(private myServiceTable: ResourcesLoaderService) {
    this.myCtx = {} as IContextNode;
    this.tableDetail = {} as IHostingnode;
    this.dataSource = [];
    //this.currentCtxId = "";
  }

  viewDetail(chosenItem: IHostingnode): void {
    this.tableDetail = chosenItem;
    //TODO: qui va passato un id da chosenItem come parametro per il service
    this.myServiceTable.getHostingNodeDetail().subscribe(res => {
      this.fetchedRawData = res;
    });
  }

  ngOnChanges(changes: SimpleChanges): void {
    for (const propName in changes) {
      if (propName === 'myCtx') {
        const param = changes[propName];
        this.myCtx = <IContextNode>param.currentValue;
        //controllo che l'oggetto non sia vuoto
        if (Object.keys(this.myCtx).length !== 0) {
          // eslint-disable-next-line no-console
          //console.log('+++++++CONTESTO PRESO DAL PARENT...' + this.myCtx.name);
          //mt qui va passato il parametro myCtx.id al rest
          this.myServiceTable.getHostingNodes().subscribe(res => {
            this.dataSource = res;
          });
        }
      }
    }
  }
}
