import { Component, OnInit, Output, EventEmitter } from '@angular/core';
import { MatTreeNestedDataSource } from '@angular/material/tree';
import { NestedTreeControl } from '@angular/cdk/tree';
import { IContextNode } from 'app/services/i-context-node';
import { MockCtxloaderService } from 'app/services/mock-ctxloader.service';

@Component({
  selector: 'jhi-ctx-tree',
  templateUrl: './ctx-tree.component.html',
  styleUrls: ['./ctx-tree.component.scss'],
  providers: [MockCtxloaderService],
})
export class CtxTreeComponent implements OnInit {
  nestedTreeControl = new NestedTreeControl<IContextNode>(node => node.children);
  nestedDataSource = new MatTreeNestedDataSource<IContextNode>();
  @Output() treeNode = new EventEmitter<IContextNode>(); //emitting event to parent

  constructor(private myService: MockCtxloaderService) {}

  hasNestedChild(_: number, node: IContextNode): boolean {
    if (node.children == null) {
      return false;
    } else {
      return node.children.length > 0;
    }
  }

  ngOnInit(): void {
    this.myService.getData().subscribe(res => {
      this.nestedDataSource.data = res;
    });
  }
}
