import { CommonModule } from '@angular/common';
import { Component, Input, OnInit } from '@angular/core';
import { IHostingnode } from 'app/services/i-hostinngnode';
import { ResourcesLoaderService } from 'app/services/resources-loader.service';

@Component({
  standalone: true,
  imports: [CommonModule],
  selector: 'jhi-rawjson-view',
  templateUrl: './rawjson-view.component.html',
  styleUrls: ['./rawjson-view.component.scss'],
  providers: [ResourcesLoaderService],
})
export class RawjsonViewComponent implements OnInit {
  @Input() chosenItem: IHostingnode | undefined;

  fetchedRawData: string | undefined;

  constructor(private myService: ResourcesLoaderService) {}

  ngOnInit(): void {
    //TODO: passare al servizio qui sotto: chosenItem.id come parametro rest
    this.myService.getHostingNodeDetail().subscribe(res => {
      this.fetchedRawData = res;
    });
  }
}
